// RegSock.cpp

#include "stdafx.h"
#include "Registry.h"
#include "RegSock.h"

/////////////////////////////////////////////////////////////////////////////
// Decode Base64 encoded src into dest, returns the number of data bytes
// stored in dest, or -1 on error
//int DecodeBase64(char *src, char *dest, int szdest);

// Encode src in Base64 into dest, returns the number of data bytes
// stored in dest, or -1 on error
//int EncodeBase64(char *src, char *dest, int szdest);

#include "base64.h"
/////////////////////////////////////////////////////////////////////////////


void CRegSock::OnAccept( int nErrorCode )
{
}

void CRegSock::OnClose( int nErrorCode )
{
	if ( nErrorCode != 0 )
		m_ParentWnd->SendMessage(WM_CLOSESOCK_ERROR, nErrorCode, 0);
	else
		m_ParentWnd->SendMessage(WM_CLOSESOCK_CLEAN, 0, 0);
}

void CRegSock::OnConnect( int nErrorCode )
{
	if ( nErrorCode != 0 )
		m_ParentWnd->SendMessage(WM_CLOSESOCK_ERROR, nErrorCode, 0);
}

void CRegSock::OnOutOfBandData( int nErrorCode )
{
}

void CRegSock::OnReceive(int nErrorCode )
{
}

void CRegSock::OnSend( int nErrorCode )
{

	CString	Package;

	/////////////////////////////////////////
	// Get Computer Name
	CRegistry	rReg;
	CString		sCName;
	static char	szRegEntry[] = "System\\CurrentControlSet\\control\\ComputerName\\ComputerName";
	static char	szRegBackup[] = "System\\CurrentControlSet\\Services\\VxD\\VNETSUP";

	if ( rReg.VerifyKey(HKEY_LOCAL_MACHINE, szRegEntry) )
	{
		rReg.Open(HKEY_LOCAL_MACHINE, szRegEntry);
		rReg.ReadString("ComputerName", sCName);
	}

	if ( sCName.IsEmpty() )
	{
		if ( rReg.VerifyKey(HKEY_LOCAL_MACHINE, szRegBackup) )
		{
			rReg.Open(HKEY_LOCAL_MACHINE, szRegBackup);
			rReg.ReadString("ComputerName", sCName);
		}
	}

	if ( sCName.IsEmpty() )
		sCName = "Computer Name Unavailable";

	Package += sCName;
	Package += ",";


	/////////////////////////////////////////
	// Get MAC Address Method #1
	UUID uuid;
	UuidCreate(&uuid);
	CString macID_1;
	macID_1.Format("%02X:%02X:%02X:%02X:%02X:%02X", 
		int(uuid.Data4[2]), int(uuid.Data4[3]), int(uuid.Data4[4]),
		int(uuid.Data4[5]), int(uuid.Data4[6]), int(uuid.Data4[7]));


	/////////////////////////////////////////
	// Get MAC Address Method #2
	NCB			Ncb;
	char		uRetCode;
	CString		macID_2;
	ASTAT		Adapter;   

	memset( &Ncb, 0, sizeof(Ncb) );
	Ncb.ncb_command = NCBRESET;
	Ncb.ncb_lana_num = 0;
	uRetCode = Netbios( &Ncb );   

	memset( &Ncb, 0, sizeof (Ncb) );
	Ncb.ncb_command = NCBASTAT;
	Ncb.ncb_lana_num = 0;
	memset( Ncb.ncb_callname, ' ', sizeof(Ncb.ncb_callname) );
	Ncb.ncb_callname[0] = '*';
	Ncb.ncb_callname[ strlen((const char*)&Ncb.ncb_callname[0]) - 1 ] = '\0';
	Ncb.ncb_buffer = (unsigned char *) &Adapter; 
	Ncb.ncb_length = sizeof(Adapter);
	uRetCode = Netbios( &Ncb );
	
	if ( uRetCode == 0 )
	{
		macID_2.Format( "%02X:%02X:%02X:%02X:%02X:%02X",
			Ncb.ncb_lana_num,
			Adapter.adapt.adapter_address[1],
			Adapter.adapt.adapter_address[2],
			Adapter.adapt.adapter_address[3],
			Adapter.adapt.adapter_address[4],
			Adapter.adapt.adapter_address[5],
			Adapter.adapt.adapter_address[6] );
	}

	////////////////////////////////////////
	// Figure out which one to use
	if ( macID_1 == macID_2 || macID_2.IsEmpty() )
		Package += macID_1;
	else
		Package += macID_2;
	Package += ",";


	////////////////////////////////////////
	// Encode Package into base64
	int		len		= Package.GetLength();
	char	*str	= Package.GetBuffer(len);
	int		bz		= ((len / 3) * 4) + 9;
	char	*buf	= (char*)calloc(bz, sizeof(char));

	if (buf == NULL)
	{
		bz = -1;
		buf = str;
	}
	else
	{
		int nRet;

		if ( (nRet = EncodeBase64(str, buf+1, bz-1)) < 0 )
		{
//			CString j;
//			j.Format("BADCODE %d", nRet);
//			AfxMessageBox(j);

			bz = -1;
			free (buf);
			buf = str;
		}
		else
			buf[0] = 5;
	}

	///////////////////////////////////////
	// Send() the date to the server
	Send(buf, strlen(buf));
	
	Close();

	if ( bz >= 0 )
		free(buf);

	m_ParentWnd->SendMessage(WM_CLOSESOCK_CLEAN, 0, 0);
}
