// ResNetRegisterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ResNetRegister.h"
#include "ResNetRegisterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CResNetRegisterDlg dialog

CResNetRegisterDlg::CResNetRegisterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CResNetRegisterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CResNetRegisterDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CResNetRegisterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CResNetRegisterDlg)
	DDX_Control(pDX, IDC_STATIC_ICON, m_IconBox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CResNetRegisterDlg, CDialog)
	//{{AFX_MSG_MAP(CResNetRegisterDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CResNetRegisterDlg message handlers

BOOL CResNetRegisterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
//	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_Connect = true;
	m_RegSock.m_ParentWnd = this;
	SetTimer(WM_TIMER_CONNECT, 5000, NULL);
	SetTimer(TIMER_SOCK_TIMEOUT, 20000, NULL);

	m_hIcons[0] = (HICON)LoadImage(GetModuleHandle(NULL), 
		MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 32, 32, 0);
	m_hIcons[1] = (HICON)LoadImage(GetModuleHandle(NULL), 
		MAKEINTRESOURCE(IDR_PAW_01), IMAGE_ICON, 32, 32, 0);
	m_hIcons[2] = (HICON)LoadImage(GetModuleHandle(NULL), 
		MAKEINTRESOURCE(IDR_PAW_02), IMAGE_ICON, 32, 32, 0);
	m_hIcons[3] = (HICON)LoadImage(GetModuleHandle(NULL), 
		MAKEINTRESOURCE(IDR_PAW_03), IMAGE_ICON, 32, 32, 0);
	m_hIcons[4] = (HICON)LoadImage(GetModuleHandle(NULL), 
		MAKEINTRESOURCE(IDR_PAW_04), IMAGE_ICON, 32, 32, 0);
	m_hIcons[5] = (HICON)LoadImage(GetModuleHandle(NULL), 
		MAKEINTRESOURCE(IDR_PAW_05), IMAGE_ICON, 32, 32, 0);
	m_hIcons[6] = (HICON)LoadImage(GetModuleHandle(NULL), 
		MAKEINTRESOURCE(IDR_PAW_06), IMAGE_ICON, 32, 32, 0);
	m_hIcons[7] = (HICON)LoadImage(GetModuleHandle(NULL), 
		MAKEINTRESOURCE(IDR_PAW_07), IMAGE_ICON, 32, 32, 0);
	m_hIcons[8] = (HICON)LoadImage(GetModuleHandle(NULL), 
		MAKEINTRESOURCE(IDR_PAW_08), IMAGE_ICON, 32, 32, 0);
	m_hIcons[9] = (HICON)LoadImage(GetModuleHandle(NULL),
		MAKEINTRESOURCE(IDR_PAW_09), IMAGE_ICON, 32, 32, 0);

	m_IconRun = true;
	m_IconNum = 0;
	SetTimer(TIMER_CHANGE_ICON, 300, NULL);

	GetDlgItem(IDC_STATIC_BOTTOM)->ShowWindow(SW_HIDE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CResNetRegisterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CResNetRegisterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CResNetRegisterDlg::OnOK() 
{
	if ( GetKeyState(VK_RETURN) >= 0 )
	{
		if (m_IconRun)
			KillTimer(TIMER_CHANGE_ICON);
		if (m_Connect)
			KillTimer(WM_TIMER_CONNECT);
		
		CDialog::OnOK();
	}
}

void CResNetRegisterDlg::OnCancel() 
{
	if ( GetKeyState(VK_ESCAPE) >= 0 )
	{
		if (m_IconRun)
			KillTimer(TIMER_CHANGE_ICON);
		if (m_Connect)
			KillTimer(WM_TIMER_CONNECT);
		
		CDialog::OnCancel();
	}
}

LRESULT CResNetRegisterDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	
	switch(message)
	{
	case WM_TIMER:
		switch(wParam)
		{
		case TIMER_SOCK_TIMEOUT:
			KillTimer(TIMER_CHANGE_ICON);
			m_IconBox.SetIcon(m_hIcons[0]);
			GetDlgItem(IDC_STATIC_STATUS)->SetWindowText(szFailure);
			GetDlgItem(IDC_STATIC_BOTTOM)->ShowWindow(SW_SHOW);
			break;
		case WM_TIMER_CONNECT:
			m_RegSock.Create();
			m_RegSock.Connect(szDefIP, nDefPort);
			KillTimer(WM_TIMER_CONNECT);
			m_Connect = false;
			break;
		case TIMER_CHANGE_ICON:
			if ( m_IconNum >= 10 )
				m_IconNum = 0;
			m_IconBox.SetIcon(m_hIcons[m_IconNum++]);
			break;
		}
		break;
	case WM_CLOSESOCK_CLEAN:
		KillTimer(TIMER_CHANGE_ICON);
		KillTimer(TIMER_SOCK_TIMEOUT);
		m_IconBox.SetIcon(m_hIcons[0]);
		GetDlgItem(IDC_STATIC_STATUS)->SetWindowText(szSuccess);
		GetDlgItem(IDC_STATIC_BOTTOM)->ShowWindow(SW_SHOW);
		break;
	case WM_CLOSESOCK_ERROR:
		KillTimer(TIMER_CHANGE_ICON);
		KillTimer(TIMER_SOCK_TIMEOUT);
		m_IconBox.SetIcon(m_hIcons[0]);
		GetDlgItem(IDC_STATIC_STATUS)->SetWindowText(szFailure);
		GetDlgItem(IDC_STATIC_BOTTOM)->ShowWindow(SW_SHOW);
		break;
	}

	return CDialog::DefWindowProc(message, wParam, lParam);
}
